import java.io.File
import java.sql.*
import java.util.*
import java.math.BigDecimal
import com.prodinf.utile.Utils
import java.util.ArrayList
import java.util.HashMap

PreparedStatement psIns
PreparedStatement psUpd

boolean ok = false
// actualizare fisiere validare revisal - vers aplicatie 6.0.8.0

try {
  ArrayList<BigDecimal> idUsers = new ArrayList<BigDecimal>()
  HashMap<String, String> fNames = new HashMap<String, String>()
  HashMap<String, BigDecimal> ids = new HashMap<String, String>()

  fNames.put("XSD_REV_ENT", "schemas_datacontract_org_2004_07_Revisal_Entities.xsd");
  fNames.put("XSD_ENT", "schemas_datacontract_org_2004_07_uNhAddIns_Entities.xsd");
  fNames.put("XSD_SER", "schemas_microsoft_com_2003_10_Serialization_.xsd");
  fNames.put("XSD_ORG", "www_w3_org_2001_XMLSchema.xsd");
  fNames.put("REV_DB", "Revisal.db");

  def SQL_INS = 'INSERT INTO TOTAL.VALID_REV (ID_FIRMA, ID, SURSA, ID_USER, DATAACT, COD, DESCRIERE) VALUES(?,?,?,?,?,?,?)'
  def SQL_UPD = 'UPDATE TOTAL.VALID_REV SET ' +
              ' SURSA = ?, ' +
              ' ID_USER = ?, ' +
              ' DATAACT = ?, ' +
              ' COD = ?, ' +
              ' DESCRIERE = ? ' +
              'WHERE ID_FIRMA = ? ' +
              'AND ID = ? '
  psIns = connection.prepareStatement(SQL_INS)
  psUpd = connection.prepareStatement(SQL_UPD)

  sql.eachRow('SELECT * from TOTAL.FIRME') { row ->
    ids.clear()
    ids.put("XSD_REV_ENT", null);
    ids.put("XSD_ENT", null);
    ids.put("XSD_SER", null);
    ids.put("XSD_ORG", null);
    ids.put("REV_DB", null);

    BigDecimal id_firma = row.id
    BigDecimal id_user = context.getOrCreateIDUtilizatorGenerat("TOTAL", id_firma)

    Set<String> s = fNames.keySet();
    String codes = "'XXXXXXX'"
    for (String string : s) {
      codes += ", '" + string + "'"
      sql.execute('DELETE FROM TOTAL.ALGSC WHERE ID_FIRMA = ? AND COD = ?', [id_firma, string])
    }

    sql.eachRow("SELECT COD, ID FROM TOTAL.VALID_REV WHERE ID_FIRMA = ? AND COD in (" + codes + ")" , [row.id]){rw ->
      ids.put(rw.cod, rw.id)
    }

    if(id_user != null){

      Set<String> keys = ids.keySet();
      for(String key : keys){
        File f = new File(parent.getPath() + File.separator + fNames.get(key))
        if(f.exists()){
          FileInputStream fis
          ByteArrayOutputStream baos
          try{
            fis = new FileInputStream(f)
            baos = new ByteArrayOutputStream(Utils.DEFAULT_BUFFERSIZE)
            Utils.copyStream(fis, baos)
            if(ids.get(key) == null){
			  def maxId = context.genereateID("TOTAL","VALID_REV", id_firma)

              psIns.clearParameters()
              psIns.setBigDecimal(1, id_firma)
              psIns.setBigDecimal(2, maxId)
              
              psIns.setBytes(3, baos.toByteArray())
              psIns.setBigDecimal(4, id_user)
              psIns.setTimestamp(5, new Timestamp(System.currentTimeMillis()))
              psIns.setString(6, key)
              psIns.setString(7, "FISIERUL " + fNames.get(key))
              psIns.addBatch()
            } else {
              psUpd.clearParameters()
              psUpd.setBytes(1, baos.toByteArray())
              psUpd.setBigDecimal(2, id_user)
              psUpd.setTimestamp(3, new Timestamp(System.currentTimeMillis()))
              psUpd.setString(4, key)
              psUpd.setString(5, "FISIERUL " + fNames.get(key))
              psUpd.setBigDecimal(6, id_firma)
              psUpd.setBigDecimal(7, ids.get(key))
              psUpd.addBatch()
            }
          } finally {
            Utils.closeQuietly(fis)
            Utils.closeQuietly(baos)
          }
        }
      }
    }
  }
  psIns.executeBatch()
  psUpd.executeBatch()
  ok = true
} finally {
  try{
    if(ok){
      connection.commit()
    }
    connection.rollback()
  } catch(Exception e){
  }

}

def getTIDQuery(String tableName, String columnName) {
  String query = ""
  if (context.getDbType() == context.MSSQL_DB) {
    query += "select  (" + tableName + "." + columnName + " + 1) as jid from total." + tableName + " " +
    tableName + " WITH (UPDLOCK NOWAIT) where " + tableName + "." + columnName +
          " = (select max(" + tableName + "." + columnName + ") from total." + tableName + " " + tableName + ")"
  }
  if (context.getDbType() == context.ORACLE_DB) {
    query += "select (" + tableName + "." + columnName + " + 1) as jid from total." + tableName + " " +
    tableName + " where " + tableName + "." + columnName +
          " = (select max(" + tableName + "." + columnName + ") from total." + tableName + " " + tableName + ") " +
    " FOR UPDATE NOWAIT"
  }
  return query
}
